
        ; TODO: Buffer1-equal-to-buffer2 checker...

        org 100h                ; .com program
start:  ; we just assume that the system CPU is 386 or newer.

        mov ah, 9
        mov dx, cpucheckmsg
        int 21h

        pushfd
        pushfd                  ; mov eax, flags
        pop eax
        mov ebx, eax
        xor eax, 200000h        ; try to toggle CPUID test thing
        push eax                ; mov flags, eax
        popfd
        pushfd                  ; mov eax, flags
        pop eax
        xor eax, ebx            ; did toggle work?
        popfd
        test eax, 200000h       ; if bit 21 was writeable...
        jnz has_cpuid

        mov ah, 9
        mov dx, nocpuidmsg
        int 21h
        mov ax, 4cfeh
        int 21h

no_tsc: mov ah, 9
        mov dx, notscmsg
        int 21h
        mov ax, 4cfeh
	int 21h

noemm386:
        mov ah, 9
        mov dx, noemmmsg
        int 21h
        mov ax, 4cfeh
	int 21h

has_cpuid:
        xor eax, eax            ; basic CPUID info
        cpuid                   ; returns vendorid ECX:EDX:EBX, info EAX
        cmp eax, 1              ; at least CPUID info 1 available?
        jb no_tsc
        mov eax, 1              ; request that info
        cpuid
        test edx, 16            ; nonzero if TSC supported
        jz no_tsc

        smsw ax                 ; unpriv'd way to detect protected mode
        test al, 1
        jz realmode             ; cr4 editing is allowed in real mode

v86mode:                        ; test for FreeDOS emm386
        push ds
        xor ax, ax
        mov ds, ax
        mov ax, [ds:(67h*4)+2]  ; int 67 handler segment
        pop ds
        or ax, ax               ; vector not set?
        jz noemm386
        cmp ax, 0xf000
        jz noemm386

        xor cx, cx              ; move 0 words
        mov si, gdt1587         ; global descriptor table for move
        mov ah, 87h             ; block move, normally only on int 15!
        int 67h                 ; FreeDOS EMM386 alias for "int 15.87"
        cmp ah, 0               ; okay? normal EMS only has int 67.40-
        jz fdemm386             ; int 67.6a plus VCPI int 67.de...
        ; MS EMM386 4.20+ install check: int 67.ffa5 returns ax=845a
        ; or (outside windows) ax=84a5, and bx:cx=entrypoint.

otheremm386:                    ; editing cr4 will likely be forbidden
        mov ah, 9
        mov dx, rdtscfailmsg
        int 21h
        mov ah, 8               ; get char
        int 21h
        cmp al, 27              ; ESC, user wants to abort?
        jnz daretsc             ; if not, just try to use RDTSC anyway
        mov ax, 4cfeh
        int 21h

        ; The following crashes with MS EMM386, but we have no choice:
        ; we need RDTSC but it is blocked in V86 and real mode if the
        ; cr4.tsd bit is on! In real mode, BIOS usually has set tsd=0.
        ; It would probably help to run "cr4 = cr4 and not 4" right
        ; before MS EMM386 versions which do not touch cr4. For FreeDOS
        ; EMM386, opcodes "0F 20 xx to 0F 23 xx" are allowed for DOS.

fdemm386:
        mov word [tsc_type], 1  ; FreeDOS EMM386 specific
        mov ah, 9
        mov dx, fdtimingmsg
        int 21h

realmode:
        mov eax, cr4            ; new for Pentium (0f 20 e0)
        and al, 0xfb            ; "and not 4" - reset TSD bit
        mov cr4, eax            ; (0f 22 e0)
                                ; now RDTSC is available in V86 mode :)
daretsc:

; ---------------------------------------------------------------

        mov ax, sp
        dec ax
        cmp ax, bufferstart + 32768 + 1024      ; enough space?
        jb near nomovstest
        mov ah, 9
        mov dx, movsmsg
        int 21h
        call starttime
        mov ebp, 32768 * 2      ; 1024 * 32k = 32M

movsloop:
        mov eax, 0x9000         ; range for segment
        call getrandom
        mov ds, ax
        mov ax, cs
        mov es, ax
        xor si, si              ; transfer: ????:n
        add si, 0       ; *** 0 for aligned/16, 8 aligned/8, 4 aligned/4
                        ; *** 2 aligned/2, 1 not aligned...
        mov di, bufferstart     ; to cs:bufferstart+n
        add di, si
        mov cx, 1024 / 4
        cld
        cli
        align 4 ; or "align 16" ; to misalign, add: times 15 db 90h
        rep movsd               ; fetch one buffer full of something
        mov ax, ds
        mov es, ax
        mov ax, cs
        mov ds, ax
        xor di, di              ; transfer: ????:n
        add di, 0       ; *** must be same alignment value as above!
        mov si, bufferstart     ; from cs:bufferstart+n
        add si, di
        mov cx, 1024 / 4
        align 4 ; or "align 16" ; to misalign, add: times 15 db 90h
        rep movsd               ; copy back buffer to somewhere
        sti
        mov ax, cs              ; reset DS and ES to CS (.com style)
        mov ds, ax
        mov es, ax
        dec ebp
        jnz movsloop

        mov bp, movstimemsg
        call showtime
nomovstest:

; ---------------------------------------------------------------

        mov ah, 9
        mov dx, startmsg
        int 21h

        call starttime
        call connectxms         ; alloc
        mov bp, alloctimemsg
        call showtime           ; time for xmssize*1024 byte alloc

        mov ecx,  32768         ; X kilobytes to be moved twice
        call starttime
copyloop:

        ; es:bx points to buffer, ax selects offset in 1 kbyte units
        mov bx, bufferstart
        movzx eax, word [xmssize]
        call getrandom          ; get 0..[xmssize] random value EAX
        push ax
        call copytoxms          ; access
        mov bx, bufferstart
        pop ax                  ; use same value as above
        call copytodos          ; access

        dec ecx
        jnz copyloop
        mov bp, copytimemsg
        call showtime           ; time for 32768*1024*2 byte move

        call starttime
        call disconnectxms      ; free
        mov bp, freetimemsg
        call showtime           ; time for xmssize*1024 byte free

        smsw ax                 ; check for protected mode
        test al, 1
        jz novcpi               ; real mode - cannot have VCPI
        ; else: we already checked if int 67 is a good pointer

        mov ax,0xde00           ; VCPI install check
        int 67h
        or ah,ah
        jz hasvcpi

novcpi: mov ah, 9
        mov dx, novcpimsg
        int 21h
        mov ax, 4c00h
        int 21h

lowramvcpi:
        mov ah, 9
        mov dx, lowrammsg
        int 21h
        mov ax, 4c00h
        int 21h

hasvcpi:
        push bx                 ; if SP was (1)0000h here
        mov ax, sp
        pop bx
        sub ax, 49152           ; used stack size: 12k dwords
        jc lowramvcpi
        cmp ax, bufferstart + 1024
        jc lowramvcpi           ; stack would grow too close

        mov ah, 9
        mov dx, vcpistartmsg
        int 21h

        mov ah, 9
        mov dx, vcpiaddrmsg
        int 21h
        mov ax, 0xde02          ; get max phys addr EDX
        int 67h
        mov eax, edx
        call showeax

        mov ah, 9
        mov dx, vcpifreemsg
        int 21h
        mov ax, 0xde03          ; get free page count
        int 67h
        mov eax, edx
        call showeax

        mov ah, 9
        mov dx, vcpiallocmsg
        int 21h
        call starttime
        mov di, sp
        mov cx, 12 * 1024       ; 12k pages, 4k each: 48 MB
vcpiloop1:
        mov ax,0xde04           ; alloc 1 page: returns EDX
        int 67h
        or ah, ah
        jnz vcpierror           ; have to break out of alloc loop
        push edx                ; page
        loop vcpiloop1
        jmp short vcpiok1

vcpierror:
        push ax
        mov ah, 9
        mov dx, vcpierrmsg1
        int 21h
        pop ax
        mov al, ah
        call showal
        mov ah, 9
        mov dx, vcpierrmsg2
        int 21h

vcpiok1:
        mov ax, di
        sub ax, sp              ; amount of actually used stack
        shr ax, 2
        call showax
        mov bp, vcpigettimemsg
        call showtime

        call starttime
vcpiloop2:                      ; free pages again. reverse order.
        cmp di, sp
        jz vcpiempty
        pop edx                 ; page
        mov ax,0xde05           ; free 1 page at EDX
        int 67h
        or ah,ah
        jz vcpiok2
        mov al, ah              ; error code
        call showal
vcpiok2:
        jmp short vcpiloop2
vcpiempty:
        mov bp, vcpifreetimemsg
        call showtime

        mov ah, 9
        mov dx, donemsg
        int 21h
        mov ax, 4c00h
        int 21h


; ---------------------------------------------------------------

getrandom:                      ; return pseudo-random number 0..EAX-1
        push edx
        push ebx
        push eax                ; store user range wish
        mov eax, [cs:prng_y]    ; y = (y*a + b) modulo m
        mov ebx, 1588635695     ; a (or use 1223106847 or 279470273)
        mul ebx
        add eax, 4294967291     ; b
        adc edx, 0
        mov ebx, 4294967291     ; 2^32 - 5 (prime, gives better PRNG)
        div ebx                 ; (for m=2^32: a=1664525 b=1013904223)
        mov eax, edx            ; "modulo m" result
        xor edx, edx
        mov [cs:prng_y], eax
        pop ebx                 ; fetch user range wish
        div ebx
        mov eax, edx            ; return value in EAX
        pop ebx
        pop edx
        ret                     ; Somewhat better "Knuth" PRNG:
                ; X_n = (271828183*X_n-1 - 314159269*X_n-2) mod (2^31-1)

; ---------------------------------------------------------------

starttime:              ; start cycle time measurement
        push eax
        push edx
        call do_rdtsc
        mov [cs:time0], eax
        mov [cs:time0+4], edx
        pop edx
        pop eax
        ret

showtime:               ; show elapsed cycles since starttime, text bp.
        push eax
        push edx
        call do_rdtsc
        push ax
        push dx
        mov dx, bp      ; message offset
        mov ah, 9
        int 21h         ; show string
        pop dx
        pop ax
        sub eax, [cs:time0]
        sbb edx, [cs:time0+4]
        or edx, edx
        jz showtime16
        xchg eax, edx
        call showeax
        xchg eax, edx
showtime32:
        call showeax
        jmp showedtime
showtime16:
        cmp eax, 10000h
        jae showtime32
        call showax
showedtime:
        mov ah, 2
        mov dl, 13      ; CR
        int 21h
        mov ah, 2
        mov dl, 10      ; LF
        int 21h
        pop edx
        pop eax
        ret

do_rdtsc:               ; read time stamp counter
        mov ax, [cs:tsc_type]
        or ax,ax        ; special RDTSC alternative selected?
        jnz fd_rdtsc
        rdtsc           ; 0f 31 (can be blocked by CR4 TSD bit)
        ret

fd_rdtsc:               ; FreeDOS EMM386 emulates RDMSR / WRMSR
        push ecx
        mov ecx,10h     ; ModelSpecificRegister 10h is the TSC
        rdmsr           ; 0f 32 (read MSR #ecx to EDX:EAX)
        pop ecx         ; (0f 30 would be other direction, wrmsr)
        ret

; ---------------------------------------------------------------

showeax:        ; display EAX value as hex
        ror eax, 16
        call showax
        ror eax, 16
        call showax
        ret

showax:         ; display AX value as hex
        xchg al, ah
        call showal
        xchg al, ah
        call showal
        ret

showal: push dx ; display AL value as hex
        mov dl, al
        shr dl, 4
        add dl, '0'
        cmp dl, '9'
        jbe nhex1
        add dl, 7       ; 'A'-('0'+10)  ; ... which is 7
nhex1:  push ax
        mov ah, 2       ; char DL to stdout
        int 21h
        pop ax
        mov dl, al
        and dl, 15
        add dl, '0'
        cmp dl, '9'
        jbe nhex2
        add dl, 7       ; 'A'-('0'+10)  ; ... which is 7
nhex2:  push ax
        mov ah, 2       ; char DL to stdout
        int 21h
        pop ax
        pop dx
        ret

; ---------------------------------------------------------------

        ; XMS helper functions
        ; copytoxms copies one sector from es:bx to XMS slot AX
        ; copytodos copies one sector from XMS slot AX to es:bx

A20KLUDGE:              ; hangs if nothing reads the waiting data!
%ifdef BOCHS_A20
        pushf           ; yes, that crappy thing finally got me:
        push ax         ; the BOCHS(.com) ROMBIOS fails to check,
        sti             ; but in 64 does not only need test 2/Z
a20k:   in al, 0x64     ; (can accept commands) BUT(!) also has to be
        test al, 3      ; test 1/Z (has -no- -other- data waiting on
        jnz a20k        ; port 60) for command 0xd0 (read A20/...
        pop ax          ; state), so iodev/keyboard.cc and
        popf            ; bios/rombios.c are at war (in BOCHS) !
                        ; (which may crash, because int 15.87, the
                        ; copy function, uses set_enable_a20 ...)
%endif
        ret

; ---------------------------------------------------------------

        ; XMS copy structure (0x10 in size):
        ; D size (512), W source handle (0 for DOS), D source (linear or
        ; pointer for DOS), W dest handle (...), D dest

copytoxms:      ; copy 1 kb from es:bx to xms bin AX
        pushf
        pusha   ; do not trust XMS
        push eax

        movzx eax, ax           ; clear high 16 bits
        shl eax, 10             ; 1024 byte granularity
        push eax                ; C dest offs
        push word [cs:xmshandle]        ; A dest: xms
        push es
        push bx                 ; 6 esbx source pointer
        push word 0             ; 4 source: dos
        push dword 1024         ; 0 size: 1024 bytes
xmscopycommon:
        mov si, sp              ; our XMS copy structure on stack
        push ds                 ; (save)
        push ss
        pop ds                  ; ... stack again ...

        call A20KLUDGE          ; wait for 8042 (if Bochs)
        mov ah, 0bh
        call doxmscall          ; XMS copy command

        pop ds                  ; (restore)
        pop eax                 ; remove...
        pop eax                 ;   XMS copy...
        pop eax                 ;     structure from...
        pop eax                 ;       stack!

        pop eax
        popa
        popf
        ret

copytodos:                      ; copy 1 kb from xms bin AX to es:bx
        pushf
        pusha                   ; do not trust XMS
        push eax

        push es
        push bx                 ; C esbx dest pointer
        push word 0             ; A dest: dos
        movzx eax, ax           ; clear high 16 bits
        shl eax, 10             ; granularity: 1024 bytes
        push eax                ; 6 source offs
        push word [cs:xmshandle]        ; 4 source: xms
        push dword 1024         ; 0 size: 1024 bytes
        jmp short xmscopycommon

; ---------------------------------------------------------------


connectxms:                     ; connect to XMS and alloc some
        mov ax, 0x4300
        mov bl, -1              ; clear errorcode value
        int 0x2f                ; xms installation check
        mov bp, noint2fmsg
        cmp al, 0x80
        jc noxms                ; xms not present
        mov ax, 0x4310
        push es
        int 0x2f                ; get xms call vector (may clobber regs)
        mov [xmsvec], bx
        mov [xmsvec+2], es
        pop es
        mov ah, 8
        call doxmscall          ; check amount of free XMS
        mov bp, nofreexmsmsg
        jc noxms

        mov bx, [cs:xmssize]    ; set BX to amount of needed XMS ***

        mov bp, toosmallxmsmsg
        mov si, dx              ; total
        cmp dx, bx              ; DX total, AX biggest chunk (kbyte)
        jb smallxms
        mov bp, fragmentedmsg
        mov si, ax              ; biggest
        cmp ax, bx
        jb smallxms             ; not enough XMS free
goxms:  mov dx, bx
        mov ah, 9
        call doxmscall          ; alloc DX kbyte for us
        mov bp, xmsallocfailmsg
        jc noxms
        mov [xmshandle], dx     ; our handle
        ret

smallxms:                       ; only AX kbytes, not BX...
        mov dx, bp
        mov ah, 9
        int 21h
        mov ax, si              ; limit
        call showax
        mov dx, smallmsg2
        mov ah, 9
        int 21h
        mov ax, si              ; limit
        mov bx, ax              ; reduce wish-size
        mov [xmssize], ax
        jmp short goxms

noxms:  mov dx, bp
        mov ah, 9
        int 21h
        mov ax, 4cffh
        int 21h

; ---------------------------------------------------------------

disconnectxms:                  ; free (de-alloc) XMS
        mov ah, 0ah             ; FREE handle
        call doxmscall
        ret

; ---------------------------------------------------------------

doxmscall:                      ; do an XMS call, with error handling
        mov [cs:xmswhat], ah    ; for the error message
        call far [cs:xmsvec]
        or ax, ax
        jz xmserror             ; ax=1 if ok
        clc                     ; ok
xmsdone:
        ret

xmserror:                       ; ax was 0, error code in BL
        push ax
        push dx
        mov al, bl              ; error code
        mov ah, [cs:xmswhat]    ; verbose :-)
        push ax
        mov ah, 9
        mov dx, xmserrormsg
        int 21h
        pop ax
        call showax
        mov ah, 2
        mov dl, 13              ; CR
        int 21h
        mov ah, 2
        mov dl, 10              ; LF
        int 21h
        pop dx
        pop ax
        stc                     ; error
        jmp short xmsdone

; -------------------------------------------------------------

prng_y          dd 1            ; "random" seed, updated on each call

time0           dd 0, 0         ; RDTSC timestamp "origin" storage
tsc_type        dw 0            ; 0 to use normal RDTSC

xmshandle       dw 0            ; handle number
xmsvec          dd 0            ; handler entry point
xmssize         dw 64000        ; in kbytes (64000 is 62.5 MB)
xmswhat         db 0            ; function code (for logging)

cpucheckmsg     db "Testing for RDTSC availability...",13,10,"$"
nocpuidmsg      db "Pentium or newer CPU needed, but no CPUID found"
                db 13,10,"$"
notscmsg        db "This CPU has no TimeStampCounter, sorry.",13,10,"$"
rdtscfailmsg    db "System is in protected mode, cannot unlock RDTSC"
                db 13,10
                db "Press ESC to abort or ENTER to continue anyway"
                db 13,10
                db "and just hope that RDTSC is already unlocked..."
                db 13,10,"$"
fdtimingmsg     db "FreeDOS EMM386 detected: Using RDMSR, not RDTSC!"
                db 13,10,"$"
noemmmsg        db "System is in protected mode but no EMM386 found!"
                db 13,10,"Giving up.",13,10,"$"

movsmsg         db "MOVSD benchmark, please wait...",13,10,"$"
movstimemsg     db "Cycles to MOVSD 32 MB of DOS RAM twice:   0x$"

startmsg        db "XMS 2 benchmark starts, please wait...",13,10,"$"
alloctimemsg    db "Cycles to allocate 62.5 MB of XMS memory: 0x$"
copytimemsg     db "Cycles to read and write 32 MB of XMS:    0x$"
freetimemsg     db "Cycles to free (de-alloc) 62.5 MB of XMS: 0x$"

novcpimsg       db "XMS benchmark done, no VCPI present. Done.",13,10,"$"
lowrammsg       db "Not enough stack space to do VCPI test.",13,10,"$"

vcpistartmsg    db "VCPI benchmark starts, please wait...",13,10,"$"
vcpiaddrmsg     db       "VCPI max physical address: 0x$"
vcpifreemsg     db 13,10,"VCPI free page count:      0x$"
vcpierrmsg1     db 13,10,"* VCPI alloc error: $"
vcpierrmsg2     db " - ending alloc loop here!",13,10,"$"
vcpiallocmsg    db 13,10,"Allocation loop: $"
vcpigettimemsg  db " pages (4k bytes each) done.",13,10
                db "Cycles to allocate VCPI memory:  0x$"
vcpifreetimemsg db "Cycles to release VCPI memory:   0x$"
donemsg         db "All benchmarks done.",13,10,"$"

noint2fmsg      db "No XMS driver found",13,10,"$"
nofreexmsmsg    db "XMS get info error",13,10,"$"
toosmallxmsmsg  db "Not enough free XMS2, using less than 62.5 MB:"
                db 13,10,"$"
fragmentedmsg   db "XMS2 too fragmented, using less than 62.5 MB:"
                db 13,10,"$"
smallmsg2       db " kbytes allocated - not more possible!",13,10,"$"
xmsallocfailmsg db "Could not alloc XMS",13,10,"$"
xmserrormsg     db "XMS error, code: $"

        align 8         ; we copy 0 words from 0:0 to 0:0...
gdt1587         dd 0,0  ; NUL           ; each: word maxoffset,
                dd 0,0  ; for BIOS      ; 3bytes address24,
                dd 0000ffffh,9300h      ; byte rights93,
                dd 0000ffffh,9300h      ; word 386stuff
                dd 0,0  ; for BIOS CS
                dd 0,0  ; for BIOS SS

        align 16
bufferstart:            ; label - buffer starts here

; -------------------------------------------------------------

        ; PRNG notes: See http://statistik.wu-wien.ac.at/prng/ for info
        ; about Lehmer LinearCongruentialPseudoRandomNumberGenerators and
        ; others... Note: NOT secure: http://www.reteam.org/papers/e59.pdf
        ; (How to crack a Linear Congruential Generator - consecutive
        ; y are on a lattice of points generated by (1,a)(0,m)... See:
        ; http://en.wikipedia.org/wiki/Linear_congruential_generator ...)

        ; LCPRNG formula: y_new = a*y_old + b (mod m), for example:
        ; m=(2^32)-5 b=4294967291 a=1588635695 or 1223106847 or 279470273
        ; m=2^?: any "a mod 4 = 1, b odd" will ensure max period length,
        ; but low bits of "random" numbers will have short repeat period.
        ; From "Numerical Recipes in C": m=2^32, a=1664525, b=1013904223.
        ; somewhat better PRNG: Knuth28, long period. m=(2^31)-1.
        ; X_n = (271828183*X_n-1 - 314159269*X_n-2) mod (2^31-1).

